#!/usr/bin/perl

package html;

use strict;

use vars qw( $data $config );

*data = *main::data;
*config = *main::config;

sub head_all
{
	my $cathegory = shift;
	if (!$cathegory) { $cathegory = 'General'; }
	my @allkeys = @_;
	if (!@allkeys) { @allkeys = sort (keys %{$data}); }
	my $text;
	$text = "<html>\n<head>\n<title>$main::VERSION: $cathegory</title>\n";
	$text .= "<style type=\"text/css\">\n<!--\n";
	$text .= 'body { color: ' . $config->{'color'}{'text'} . '; background: ' . $config->{'color'}{'bgcolor'} . "; }\n";
	$text .= 'td { color: ' . $config->{'color'}{'text'} . '; background: ' . $config->{'color'}{'normal'} . "; text-align: left; vertical-align: top; }\n";
	$text .= 'td.subhdr { color: ' . $config->{'color'}{'text'} . '; background: ' . $config->{'color'}{'subhdr'} . "; font-weight: bold; }\n";
	$text .= 'th { color: ' . $config->{'color'}{'text'} . '; background: ' . $config->{'color'}{'header'} . "; text-align: center; vertical-align: middle; }\n";
	$text .= "-->\n</style>\n";
	$text .= "</head>\n\n<body bgcolor=\"$config->{'color'}{'bgcolor'}\" text=\"$config->{'color'}{'text'}\" link=\"$config->{'color'}{'links'}\" vlink=\"$config->{'color'}{'links'}\" alink=\"$config->{'color'}{'links'}\">\n";
	$text .= "<h1><img src=\"logo.gif\" width=\"32\" height=\"32\" border=\"0\"> $main::VERSION: $cathegory</h1>\n\n<a name=\"beginofpage\">\n<p>";
	foreach my $key1 ('General', @allkeys)
	{
		if ($key1 eq $cathegory)
		{
			$text .= "[ $key1 ] ";
		}
		else
		{
			my $link;
			if (!($key1 eq 'General')) { $link = $key1; }
			else { $link = 'index'; }
			$text .= "[ <a href=\"$link.html\">$key1</a> ] ";
		}
	}
	$text .= "</p>\n<p>";
	foreach my $var1 (escape (sort (keys %{$data->{$cathegory}})))
	{
		$text .= "<nobr>[ <a href=\"#$var1\">$var1</a> ]</nobr> ";
	}
	$text .= "</p>\n\n";
	return $text;
}

sub head_top
{
	my $cathegory = shift;
	if (!$cathegory) { $cathegory = 'General'; }
	my $text;
	$text = "<html>\n<head>\n<title>$main::VERSION: $cathegory</title>\n";
	$text .= "<style type=\"text/css\">\n<!--\n";
	$text .= 'body { color: ' . $config->{'color'}{'text'} . '; background: ' . $config->{'color'}{'bgcolor'} . "; }\n";
	$text .= 'td { color: ' . $config->{'color'}{'text'} . '; background: ' . $config->{'color'}{'normal'} . "; text-align: left; vertical-align: top; }\n";
	$text .= 'td.subhdr { color: ' . $config->{'color'}{'text'} . '; background: ' . $config->{'color'}{'subhdr'} . "; font-weight: bold; }\n";
	$text .= 'th { color: ' . $config->{'color'}{'text'} . '; background: ' . $config->{'color'}{'header'} . "; text-align: center; vertical-align: middle; }\n";
	$text .= "-->\n</style>\n";
	$text .= "</head>\n\n<body>\n";
	$text .= "<h1><img src=\"logo.gif\" width=\"32\" height=\"32\" border=\"0\"> $main::VERSION: $cathegory</h1>\n\n<a name=\"beginofpage\">\n<p>";
	foreach my $key1 (sort (keys %$data))
	{
		$text .= "[ <a href=\"#$key1\">$key1</a> ] ";
	}
	$text .= "</p>\n";
	return $text;
}

sub foot
{
	my $text = "<hr>\n<p align=\"right\"><font size=\"2\">generated with \&quot;$main::VERSION\&quot;<br>\nwritten by $main::AUTHOR \&lt;<a href=\"mailto:$main::EMAIL\">$main::EMAIL</a>\&gt;<br>\nget the newest version from <a href=\"$main::HOMEPAGE\" target=\"_blank\">$main::HOMEPAGE</a></font></p>\n";
	$text .= "</body>\n</html>\n";
	return $text;
}

sub escape
{
	return map
	{
		s/</\&lt;/g;
		s/>/\&gt;/g;
		s/"/\&quot;/g;
		$_;
	} (@_);
}

1;
