#!/usr/bin/perl

package data;

use strict;

use vars qw ( $data @cntkeys @sumkeys @bytkeys );

*data = *main::data;
@cntkeys = ();
@sumkeys = ();
@bytkeys = ();

print "Saving data two-dimensional (complex) <parser/two_dimensional.pm>\n" if $main::debug;

sub init
{
	my %init_data = @_;

	foreach my $key (sort (keys %init_data))
	{
		if (defined $main::config->{'print'}{lc ($key)})
		{
			if (lc ($init_data{$key}) eq 'sum') { push (@sumkeys, $key); }
			# other types go here
			elsif (lc ($init_data{$key}) eq 'byte') { push (@bytkeys, $key); }
			elsif (lc ($init_data{$key}) eq 'count') { push (@cntkeys, $key); }
			else
			{
				warn "Unknown type \"" . $init_data{$key} . "\" for key $key, assuming 'count'\n";
				push (@cntkeys, $key);
			}
		}
	}
}

sub save
{
	my $hash = shift;

	my ($key1, $val1, $key2, $val2, $amount);

	foreach $key1 (@sumkeys, @bytkeys)
	{
		foreach $key2 ($key1, @cntkeys)
		{
			sum ($key1, $key2, $hash->{$key1}, $hash->{$key2});
		}
	}

	foreach $key1 (@cntkeys)
	{
		foreach $key2 (@sumkeys, @bytkeys)
		{
			sum ($key1, $key2, $hash->{$key1}, $hash->{$key2});
		}
		foreach $key2 (@cntkeys)
		{
			count ($key1, $key2, $hash->{$key1}, $hash->{$key2});
		}
	}
}

sub count
{
	my ($key1, $key2, $val1, $val2) = @_;
	return unless ($val1 and $val2);
	
	++$data->{$key1}{$val1}{$key2}{$val2};
}

sub sum
{
	my ($key1, $key2, $val1, $val2) = @_;
	return unless ($val1 and $val2);
	
	if ($key1 eq $key2) { $data->{$key1}{'General'}{$key1}{'General'} += $val1; }
	elsif (grep ($key1 eq $_, (@sumkeys, @bytkeys)))
	{
		$data->{$key1}{'General'}{$key2}{$val2} += $val1;
	}
	else
	{
		$data->{$key1}{$val1}{$key2}{'General'} += $val2;
	}
}

1;
